;============================================================================
;
;   COPYRIGHT 1994 WALTER C. PAYNE
;
;   THESE PROCEDURES ARE PROVIDED PURELY AS SAMPLE CODE, WITH ABSOLUTELY NO
;   WARRANTIES OF ANY KIND.  THEY MAY BE USED, MODIFIED AND/OR DISTRIBUTED
;   AS LONG AS THIS NOTICE IS RETAINED.  
;
;============================================================================

PROC waitproc.generic(TriggerType,EventRecord,CycleNumber)
   private WIN.NAME,
           WIN.DOW
IMAGERIGHTS
   SWITCH
      CASE TriggerType = "EVENT":
         SWITCH
            CASE (EventRecord["TYPE"] = "KEY") :   ; received a key event
               IF ISASSIGNED(events[UPPER(TABLE())+"->KEY->"+STRVAL(EventRecord["KEYCODE"])]) THEN
                  EXECPROC events[UPPER(TABLE())+"->KEY->"+STRVAL(EventRecord["KEYCODE"])]
                  RETURN RETVAL   ; table specific key event
               ELSE
                  IF ISASSIGNED(events["KEY->"+STRVAL(EventRecord["KEYCODE"])]) THEN
                     EXECPROC events["KEY->"+STRVAL(EventRecord["KEYCODE"])]

                     RETURN  RETVAL  ; generic key event
                  ELSE
                     RETURN acceptevent ; NON-TRAPPED key
                  ENDIF
               ENDIF

            CASE (EventRecord["TYPE"] = "MOUSE") :  ; received a mouse event
               EventRecord["WINDOW"] = WINDOWAT(EventRecord["ROW"], EventRecord["COL"])
               IF ISASSIGNED(events[UPPER(TABLE())+"->MOUSE->"+EventRecord["ACTION"]+"->"+UPPER(STRVAL(EventRecord["DOUBLECLICK"]))]) THEN
                  EXECPROC events[UPPER(TABLE())+"->MOUSE->"+EventRecord["ACTION"]+"->"+UPPER(STRVAL(EventRecord["DOUBLECLICK"]))]
                  RETURN RETVAL    ; table specific mouse event
               ELSE
                  IF ISASSIGNED(events["MOUSE->"+EventRecord["ACTION"]+"->"+UPPER(STRVAL(EventRecord["DOUBLECLICK"]))]) THEN
                     EXECPROC events["MOUSE->"+EventRecord["ACTION"]+"->"+UPPER(STRVAL(EventRecord["DOUBLECLICK"]))]
                     RETURN RETVAL   ; generic mouse event
                  ELSE
                     RETURN acceptevent     ; no mouse event
                  ENDIF
               ENDIF

            CASE (EventRecord["TYPE"] = "IDLE") :
               IF ISASSIGNED(events[UPPER(TABLE())+"->IDLE"]) THEN
                  EXECPROC events[UPPER(TABLE())+"->IDLE"]
                  RETURN RETVAL  ; table specific idle event
               ELSE
                  IF ISASSIGNED(events["IDLE"]) THEN
                     EXECPROC events["IDLE"]
                     RETURN RETVAL  ; generic idle event
                  ELSE
                     RETURN acceptevent  ; no idle event defined
                  ENDIF
               ENDIF

            CASE (EventRecord["MESSAGE"] = "MENUSELECT") :
                    ; MENU TAG
               IF ISASSIGNED(events["MENU->"+EventRecord["MENUTAG"]]) THEN
                  EXECPROC events["MENU->"+EventRecord["MENUTAG"]]

                  RETURN RETVAL
               ELSE
                  RETURN acceptevent
               ENDIF

            OTHERWISE:                    ; MESSAGE
               IF ISASSIGNED(events["MESSAGE->"+ EventRecord["MESSAGE"]]) THEN
                  EXECPROC events["MESSAGE->"+ EventRecord["MESSAGE"]]
                  RETURN RETVAL
               ELSE
                  RETURN acceptevent
               ENDIF
         ENDSWITCH
      CASE TriggerType <> "EVENT":
         SWITCH
            CASE triggerscope[TriggerType] = "FIELD":
               IF ISASSIGNED(events[TriggerType+"->"+UPPER(TABLE())+"->"+UPPER(FIELD())]) THEN
                  EXECPROC events[TriggerType+"->"+UPPER(TABLE())+"->"+UPPER(FIELD())]
                  RETURN RETVAL  ; table specific fld event
               ELSE
                  IF ISASSIGNED(events[TriggerType+"->"+UPPER(FIELD())]) THEN
                     EXECPROC events[TriggerType+"->"+UPPER(FIELD())]
                     RETURN RETVAL  ; generic fld event
                  ELSE
                     RETURN acceptevent
                  ENDIF
               ENDIF
            CASE triggerscope[TriggerType] = "TABLE" OR
               triggerscope[TriggerType] = "RECORD" OR
               triggerscope[TriggerType] = "PAGE" :
               IF ISASSIGNED(events[TriggerType+"->"+UPPER(TABLE())]) THEN
                  EXECPROC events[TriggerType+"->"+UPPER(TABLE())]
                  RETURN RETVAL ; table specific table/record/page event
               ELSE
                  IF ISASSIGNED(events[TriggerType]) THEN
                     EXECPROC events[TriggerType]
                     RETURN RETVAL   ; generic table/record/page event
                  ELSE
                     RETURN acceptevent ; no table/record/page eventproc
                  ENDIF
               ENDIF
         ENDSWITCH
   ENDSWITCH
   WINDOW HANDLE CURRENT TO WIN.NAME
   WINDOW GETATTRIBUTES WIN.NAME TO WIN.DOW
   IF WIN.DOW["TYPE"] = "FORM" OR
      WIN.DOW["TYPE"] = "IMAGE" THEN
      IF WIN.DOW["MAXIMIZED"] <> TRUE THEN
         removeframe()
      ENDIF
   ENDIF

   IMAGERIGHTS
   RETURN acceptevent     
   ENDPROC
WRITELIB LIBNAME waitproc.generic
RELEASE PROCS WAITPROC.GENERIC
;============================================================================
PROC Initscope.u()
   acceptevent = 0
   rejectevent = 1
   rejecteventexit = 2

; initialize the array of trigger scopes.  This is used to
; determine the appropriate wait event procedure to call when a
; particular trigger occurs

   DYNARRAY triggerscope[]

   triggerscope["DEPARTFIELD"] = "FIELD"
   triggerscope["ARRIVEFIELD"] = "FIELD"
   triggerscope["REQUIREDVALUE"] = "FIELD"
   triggerscope["PASSRIGHTS"] = "FIELD"

;   triggerscope["IMAGERIGHTS"] = "FIELD" ; usually want at table level
;   triggerscope["VALCHECK"] = "FIELD" ; usually want at table level

   triggerscope["DEPARTROW"] = "RECORD"
   triggerscope["ARRIVEROW"] = "RECORD"
   triggerscope["TOUCHRECORD"] = "RECORD"
   triggerscope["POSTRECORD"] = "RECORD"

   triggerscope["DEPARTTABLE"] = "TABLE"
   triggerscope["ARRIVETABLE"] = "TABLE"
   triggerscope["DISPLAYONLY"] = "TABLE"
   triggerscope["READONLY"] = "TABLE"
   triggerscope["IMAGERIGHTS"] = "TABLE" ; could be field level
   triggerscope["VALCHECK"] = "TABLE" ; could be field level

   triggerscope["DEPARTPAGE"] = "PAGE"
   triggerscope["ARRIVEPAGE"] = "PAGE"

   triggerscope["ARRIVEWINDOW"] = "WINDOW"

RETURN
ENDPROC
WRITELIB LIBNAME Initscope.u
RELEASE PROCS Initscope.u
;===========================================================================
PROC Initeventproc.u()

   ; INITIALIZE GENERIC EVENTS.  IF SPECIFIC EVENTS NEEDED, INITIALIZE IN
   ; CALLING PROC OR REFERENCE A SPECIFIC PROC TO INITIALIZE.

   DYNARRAY events[]

   ; events["EVENTTYPE->TABLE->FIELD"] = "procname"
   ;  generic calls for fld level events
   ;  generic table/record/page level events

   events["POSTRECORD"] = "post.generic"
   events["ARRIVETABLE"] = "at.generic"

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

   ; events["TABLE->KEY->keycode"] = "procname"
   ; generic key events
   events["KEY->-59"] = "PASSKEY" ;"customhelp"      ; F1
   events["KEY->-60"] = "exitproc"        ; F2
   events["KEY->-61"] = "UP.IMAGE"      ; F3
   events["KEY->-62"] = "DOWN.IMAGE"      ; F4
   events["KEY->-63"] = "CHNGREC"      ; F5
   events["KEY->-65"] = "KEYFORM"      ; F7
   events["KEY->-66"] = "VALUEADD"      ; F8
   events["KEY->-133"] = "RESSERCH.U"    ; F11
   events["KEY->-134"] = "ADDRES.U"     ; F12
   events["KEY->-82"] = "Insertrecord.n"    ; ins
   events["KEY->-32"] = "DAZE"         ; Alt-D
   events["KEY->-46"] = "COPYREC"         ; Alt-C
   events["KEY->-83"] = "deleterecord"    ; del
   events["KEY->26"] = "zoom.l"           ; zoom
   events["KEY->6"] = "fviewctrl"      ; Fieldview
   events["KEY->-108"] = "fviewctrl"   ; Fieldview

   ; events["TABLE->MOUSE->action->doubleclick(true/false)"] = "procname"
   ; generic mouse events
   events["MOUSE->DOWN->TRUE"] = "fviewctrl"

   ;message events
   ; events["MENU->menutag"]
   events["MENU->EXIT"] = "exitproc"
   events["MENU->INSERTRECORD"] = "Insertrecord.n"
   events["MENU->DELETERECORD"] = "Deleterecord"
   events["MENU->PRINTREC"] = "Printrec"
   events["MENU->COPYREC"] = "COPYrec"
   events["MENU->COEDITKEY"] = "COEDITTBL"
   events["MENU->MAINMODE"] = "COEDITTBL"
   events["MENU->DOSORT"] = "DOSORT"
   events["MENU->PICKFORM"] = "FORMPICK"
   events["MENU->FORMTOGGLE"] = "FORMTOGGLE"
   events["MENU->TBLADD"] = "TBLADD"


RETURN
ENDPROC
WRITELIB LIBNAME Initeventproc.u
RELEASE PROCS Initeventproc.u
;===========================================================================
PROC UP.IMAGE()
   private WINCOUNT.R,
           WINCOUNT.N,
           A
; PASSES KEY THROUGH WHEN USING EXECPROC - ALLOWS FUNCTION KEYS TO PASS
; ADDS A removeframe() FOR F3 OPERATION AND CHECKS IF F3 IS A VALID KEY

WINDOW LIST TO WINCOUNT.R
WINCOUNT.N = ARRAYSIZE(WINCOUNT.R)
ECHO OFF
fk.a = ""
   WHILE WINCOUNT.N > 1
      WINNEXT
      WINCOUNT.N = WINCOUNT.N - 1
   ENDWHILE
removeframe()
ECHO NORMAL
RETURN 1
ENDPROC
WRITELIB LIBNAME UP.IMAGE
RELEASE PROCS UP.IMAGE
;===========================================================================
PROC DOWN.IMAGE()
   private WINCOUNT.R,
           WINCOUNT.N
; PASSES KEY THROUGH WHEN USING EXECPROC - ALLOWS FUNCTION KEYS TO PASS
; ADDS A removeframe() FOR F4 OPERATION AND CHECKS IF F4 IS A VALID KEY

WINDOW LIST TO WINCOUNT.R
WINCOUNT.N = ARRAYSIZE(WINCOUNT.R)
ECHO OFF
fk.a = ""
IF WINCOUNT.N > 1 THEN
WINNEXT
removeframe()
ENDIF
ECHO NORMAL
RETURN 1
ENDPROC
WRITELIB LIBNAME DOWN.IMAGE
RELEASE PROCS DOWN.IMAGE
;===========================================================================
PROC FORMPICK()
   MENU
   {IMAGE}
   {PICKFORM}
RETURN 1
ENDPROC
WRITELIB LIBNAME FORMPICK
RELEASE PROCS FORMPICK
;===========================================================================
PROC TBLADD()
   private TBLNEW.A

SHOWTABLES DIRECTORY() "SELECT TABLE TO BE ADDED/MOVED TO" TO TBLNEW.A

IF NOT ISTABLE(TBLNEW.A) THEN
   RETURN 1
ENDIF
IF ISONWORKSPACE(TBLNEW.A) THEN
   MOVETO TBLNEW.A
   removeframe()
   RETURN 1
ENDIF
IF SYSMODE() = "Main" OR SYSMODE() <> "CoEdit" THEN
   VIEW TBLNEW.A
   removeframe()
   RETURN 1
ELSE
   MENU {TABLEADD} SELECT TBLNEW.A
   removeframe()
   RETURN 1
ENDIF
RETURN 3
ENDPROC
WRITELIB LIBNAME TBLADD
RELEASE PROCS TBLADD
;============================================================================
PROC COEDITTBL()
PRIVATE FORM.L
ECHO OFF
IF ISFORMVIEW() THEN
   FORM.L = TRUE
 ELSE
   FORM.L = FALSE
ENDIF
IF SYSMODE()= "Main" THEN
   IF NOT ISONWORKSPACE(TBLNAME.A) THEN
      COEDIT TBLNAME.A
   ELSE
      COEDITKEY
      MOVETO TBLNAME.A
   ENDIF
   removeframe()
   ITWASEDITED.L = TRUE
   MENUDISABLE "COEDITKEY"
   MENUDISABLE "DOSORT"
   MENUENABLE "VALUEADD"
   MENUENABLE  "MAINMODE"
   MENUENABLE "COPYREC"
   MENUENABLE "DELETERECORD"
   MENUENABLE "INSERTRECORD"
   IF ISASSIGNED(EventRecord) THEN
   waitproc.generic("ARRIVETABLE",EventRecord,CycleNumber)
   ENDIF
   SPEEDBAR " F2 ":-60," INS REC ":-82," DEL REC ":-83," COPY REC ":-46

ELSE
   ECHO NORMAL
   EXITPROC()
   MENUDISABLE "VALUEADD"
   MENUDISABLE "MAINMODE"
   MENUENABLE  "COEDITKEY"
   MENUENABLE "DOSORT"
   MENUDISABLE "COPYREC"
   MENUDISABLE "DELETERECORD"
   MENUDISABLE "INSERTRECORD"
   CLEARSPEEDBAR
ENDIF
MOVETO TBLNAME.A
IF FORM.L THEN
   IF NOT ISFORMVIEW() THEN
      FORMKEY
      removeframe()
   ENDIF
ENDIF
ECHO NORMAL
SETHIGHLIGHT CURRENT RECORD 79
SETHIGHLIGHT CURRENT FIELD 112

RETURN 1
RETURN
ENDPROC
WRITELIB LIBNAME COEDITTBL
RELEASE PROCS COEDITTBL
;===========================================================================
PROC KEYFORM()
     FORMKEY
     removeframe()
     RETURN 1
RETURN
ENDPROC
WRITELIB LIBNAME KEYFORM
RELEASE PROCS KEYFORM
;===========================================================================
PROC fviewCtrl()
     IF SYSMODE() = "CoEdit" THEN
        IF RECORDSTATUS("NEW") THEN
           mode.a = ""
        ELSE
          IF RECORDSTATUS("LOCKED") THEN
             mode.a = "UPDATE"
          ELSE
             mode.a = "READONLY"
          ENDIF
        ENDIF
     ELSE
        mode.a = "READONLY"
     ENDIF
     fview(mode.a,8)
     IF mode.a = "READONLY" AND SYSMODE() = "CoEdit" THEN
        UNLOCKRECORD
     ENDIF
     ; recursively call waitproc to reset prompt
     waitproc.generic("ARRIVETABLE",EventRecord,CycleNumber)
     RETURN 1
RETURN
ENDPROC
WRITELIB LIBNAME fviewctrl
RELEASE PROCS FVIEWCTRL
;============================================================================
PROC deleterecord()

   SHOWDIALOG "Delete Record"
      @ 6, 10
      HEIGHT 7
      WIDTH 54
      @ 1, 4 ?? "Are you sure you want to delete this record?"
      PUSHBUTTON @ 3, 11 WIDTH 12
         "~O~K"
         OK
         VALUE "OK"
         TAG "OKButton"
      TO OKButton
      PUSHBUTTON @ 3, 30 WIDTH 12
         "~C~ancel"
         CANCEL
         VALUE "Cancel"
         TAG "CancelButton"
      TO CancelButton

   ENDDIALOG
   IF RETVAL = TRUE THEN
      IMAGERIGHTS
      DEL
      IF NOT ISBLANK(WINDOW()) THEN
         MESSAGE WINDOW()
      ENDIF
      IMAGERIGHTS UPDATE
   ENDIF
   inserting = FALSE
   MENUENABLE "ExitOpts"
   RETURN rejectevent
RETURN
ENDPROC
WRITELIB LIBNAME deleterecord
RELEASE PROCS DELETERECORD
;=============================================================================

PROC removeframe()
     PRIVATE hForm,atrWin
     WINDOW HANDLE FORM TO hForm
     WINDOW GETATTRIBUTES hForm TO atrWin
     atrWin["HASFRAME"] = FALSE
     atrWin["MAXIMIZED"] = TRUE
     atrWin["CANMOVE"] = FALSE
     atrWin["CANRESIZE"] = FALSE
     atrWin["CANCLOSE"] = FALSE
     WINDOW removeframeUTES hForm FROM atrWin
RETURN
ENDPROC
WRITELIB LIBNAME removeframe
RELEASE PROCS REMOVEFRAME
;============================================================================
PROC post.generic()
     IF SYSMODE() <>  "CoEdit" THEN
        RETURN 2
     ENDIF
     POSTRECORD NOPOST LEAVELOCKED
     IF RETVAL THEN
        UNLOCKRECORD
        MESSAGE "Record posted successfully - continuing"
        IMAGERIGHTS ;UPDATE
        inserting = FALSE
        MENUENABLE "ExitOpts"
        RETURN acceptevent                       ; postrecord
     ELSE
        MESSAGE "Duplicate record created - please correct"
        RETURN rejectevent                       ; postrecord
     ENDIF
RETURN
ENDPROC
WRITELIB LIBNAME post.generic
RELEASE PROCS POST.GENERIC
;=============================================================================
PROC at.generic()
     PROMPT TABLE() + " TBL - "+SYSMODE()+" \179 Press <F2> TO exit"
     IF NOT inserting THEN
        IMAGERIGHTS ;UPDATE
     ENDIF
     RETURN acceptevent                          ; arrivetable
RETURN
ENDPROC
WRITELIB LIBNAME at.generic
RELEASE PROCS AT.GENERIC
;=============================================================================
PROC exitproc()
     IF ISFIELDVIEW() THEN          ; just in case in memo field
        DO_IT!
        RETURN rejectevent          ; deny exit, stay in the wait
     ELSE
        ECHO OFF
        POST.GENERIC()
        DO_IT!
        waitproc.generic("ARRIVETABLE",EventRecord,CycleNumber)
        IF SYSMODE() = "Main" THEN
           RETURN rejecteventexit   ; deny exit & exit the wait
        ELSE
           ECHO NORMAL
           RETURN rejectevent       ; unable to exit coedit, stay in WAIT
        ENDIF
     ENDIF
RETURN
ENDPROC
WRITELIB LIBNAME exitproc
RELEASE PROCS EXITPROC
;=============================================================================

PROC Insertrecord.n()
     IMAGERIGHTS
     inserting = TRUE                ; set flag to identify insert
     INS
     RETURN 1 ;CHANGED FROM acceptevent
RETURN
ENDPROC
WRITELIB LIBNAME Insertrecord.n
RELEASE PROCS Insertrecord.n

;=============================================================================
; Generic wait startup proc
;=============================================================================

proc setup.wait(tblname.a, mode.a,fk.a)


Initscope.u()                   ; assign a scope (Field/Rec/Tbl) to each trigger
Initeventproc.u()              ; assign procedures to each Generic event
VIEW tblname.a
removeframe()                   ;maximize & remove frame (forms & tables)
IF MODE.A = "COEDIT" then  ;do we want to go right to coedit mode?
      COEDITTBL()
ENDIF
IF ISASSIGNED(fk.a) THEN        ;do we want formview?
   IF fk.a = 1 THEN
     FORMKEY
     removeframe()     ; call custom proc to maximize form & remove frame
   ELSE
     PICKFORM fk.a
     removeframe()     ; call custom proc to maximize form & remove frame
   ENDIF
ENDIF
;IMAGERIGHTS UPDATE
PROMPT TABLE() + " TBL - "+SYSMODE()+" \179 Press <F2> TO exit"
ECHO NORMAL

IF ISASSIGNED(PULLMENU.A) THEN    ; What showpulldown menu do we use, if any
   EXECPROC PULLMENU.A
ENDIF

WAIT WORKSPACE
   PROC "waitproc.generic"
   KEY "ALL"
   MOUSE "DOWN"
   MESSAGE "MENUSELECT"
   TRIGGER "ARRIVETABLE","ARRIVEFIELD","POSTRECORD","DEPARTFIELD"
ENDWAIT
ECHO OFF
IF RETVAL > 2002 THEN
   MESSAGE "Invalid exit of WAIT - entering debug mode"
   DEBUG
ENDIF
CLEARPULLDOWN
SAVETABLES
MESSAGE ""
CLEARALL
ALTSPACE {DESKTOP} {EMPTY}
SETCANVAS DEFAULT
CLEARSPEEDBAR
RELEASE VARS fk.a
RETURN
ENDPROC
WRITELIB LIBNAME setup.wait
RELEASE PROCS SETUP.WAIT
